(defun Tokkie ( $txt1 $txt2 %lst %plist / err fn fp dcl nof-tog cur-tog tokkie-list slider-index return)
  (Tokkie_Init)
  (Tokkie_Dialog)
  (Tokkie_Exit)
  (terpri)
  (reverse return)
)

(defun Tokkie_Init ()
  (setq err *error* *error* Tokkie_err)
  (cond
    ((not (setq fn (vl-filename-mktemp "Tokkie.dcl"))))
    ((not (setq fp (open  fn "w"))))
    ((null %lst))
    ; tokkie-list keeps toggle value (default "1") for each member in %lst
    (t (setq nof-tog (length %lst))) 
  )
  ; if a previous list was used restore settings
  (if (and (not (null %lst)) (not (null %plist)))
    (setq tokkie-list (mapcar '(lambda (x)(if (member x %plist)(chr 49)(chr 48))) %lst))
    (setq tokkie-list (mapcar '(lambda (x) (chr 49)) %lst)))
  
  (if (null %lst)
    (progn (alert "Nothing to show")(Tokkie_Exit))
    (progn
      (Tokkie_write_header)
      (if (<= nof-tog 10)(Tokkie_write_body1 %lst)(Tokkie_write_body2 %lst))
      (Tokkie_write_footer)
    )
  )
  (if fp (close fp))(gc)
  (setq slider-index 0)
)

(defun Tokkie_err (s) (princ s)(Tokkie_Exit)(princ))
(defun Tokkie_Exit ()
  (setq *error* err)
  (if fp (close fp))
  (if dcl (unload_dialog dcl))
  (if (and fn (findfile fn))(vl-file-delete fn))
)


(defun Tokkie_write_header ()
  (write-line
    (strcat
      "Tokkie:dialog{label=\"Moulder\";spacer;spacer;"
      ":text_part {key=\"txt1\";width=32;fixed_width=true;}"
      ":text_part{key=\"txt2\";width=32;fixed_width=true;}spacer;") fp))


(defun Tokkie_write_body1 ( %lst / i )
  (write-line ":boxed_column{" fp)
  (setq i 0)
  (mapcar '(lambda (x)
	     (write-line
	       (strcat
		 ":row{spacer;:toggle{key=\"tg" (itoa i) "\";width=2;fixed_width=true;}"
		 ":text_part{key=\"tp" (itoa i) "\";label=\"" x "\";width=32;fixed_width=true;}}") fp)
	     (setq i (1+ i)))
	  %lst
  )
  (repeat (- 10 i)(write-line ":row{height=1.5;}" fp))
  (write-line "}spacer;" fp)
)

(defun Tokkie_write_body2 ( %lst / i )
  (write-line ":boxed_row {:column{" fp)
  (setq i 0)
  (repeat 10
    (write-line
      (strcat
	":row { spacer; :toggle { key =\"tg" (itoa i) "\";width=2;fixed_width=true;}"
	":text_part{key=\"tp" (itoa i) "\";label=\"" (nth i %lst) "\";width=32;fixed_width=true;}}") fp)
    (setq i (1+ i))
  )
  (write-line
    (strcat "}:column{:slider{key=\"sldr\";layout=vertical;min_value="(itoa (- 0 nof-tog)) ";max_value=0" 
	    ";small_increment=1;big_increment=10;value=0;}}}spacer;") fp)
)

(defun Tokkie_write_footer ()
  (write-line
    (strcat
      "spacer;"
      "spacer;ok_only;}") fp))

(defun Tokkie_Dialog ( / n drv inp)
  (if (and (setq n 0 dcl (load_dialog fn)) (new_dialog "Tokkie" dcl))
    (progn
      (Tokkie_DialogUpdate)
      (Tokkie_DialogActions)
      (setq drv (start_dialog))
      (if (= drv 1)
	(mapcar '(lambda (x y) (if (= x "1")(setq return (cons y return)))) tokkie-list %lst)
	(setq return nil))
    )
  )
)

(defun Tokkie_DialogUpdate ( / i )
  (if (= (type $txt1) 'STR)(set_tile "txt1" $txt1))
  (if (= (type $txt2) 'STR)(set_tile "txt2" $txt2))
  (set_tile "sldr" (itoa slider-index))
  (update_tokkies)
)

(defun Tokkie_DialogActions ()
  (repeat 10 (action_tile (strcat "tg" (itoa n)) (strcat "(toggle_me $value " (itoa n) ")" ))(setq n (1+ n)))
  (action_tile "sldr"	"(update_slider $value)")
  (action_tile "ok"	"(done_dialog 1)")
  (action_tile "cancel"	"(done_dialog 0)")
)

(defun update_slider ( #i )
  (setq slider-index (atoi #i))
  (Tokkie_DialogUpdate)
)

(defun update_tokkies (/ tokkie-index tokkie-name i)
  ;max number of toggles in dialog is 10
  (if (> (abs slider-index) (- nof-tog 10))
    (setq tokkie-index (- nof-tog 10))(setq tokkie-index (abs slider-index)))
  (if (< tokkie-index 0)(setq tokkie-index 0))
  (setq i 0)
  (while (and (< i 10) (setq tokkie-name (nth tokkie-index %lst)))
    (set_tile (strcat "tp" (itoa i)) tokkie-name)
    (set_tile (strcat "tg" (itoa i)) (nth tokkie-index tokkie-list))
    (setq i (1+ i) tokkie-index (1+ tokkie-index))
  )
)

	 
(defun toggle_me ( $v #i / idx )
  (if (> (abs slider-index) (- nof-tog 10))(setq idx (- nof-tog 10))(setq idx (abs slider-index)))
  (setq tokkie-list (nthSubst (+ #i (if (< idx 0) 0 idx)) $v tokkie-list))
)

(defun Tokkie_SelectAll ();reset all toggles to "1"
  (setq tokkie-list (mapcar '(lambda (x) (chr 49)) %lst))(Tokkie_DialogUpdate))

(defun Tokkie_SelectNone ();reset all toggles to "0"
  (setq tokkie-list (mapcar '(lambda (x) (chr 48)) %lst))(Tokkie_DialogUpdate))

(defun nthSubst (i x l / n) (setq n -1)(mapcar '(lambda (y) (if (eq i (setq n (1+ n))) x y )) l ))

(defun StringSubst ( new old str / inc len )
    (setq len (strlen new)
          inc 0
    )
    (while (setq inc (vl-string-search old str inc))
        (setq str (vl-string-subst new old str inc)
              inc (+ inc len)
        )
    )
    str
)

(defun c:moulder ()  
  ;; Collect list of layers as strings
  (setq layerList '())
  (setq layerTable (vla-get-layers (vla-get-activedocument (vlax-get-acad-object))))
  (vlax-for layer layerTable
    (setq layerName (vlax-get-property layer 'Name)) ; Convert layer name to string
    (setq layerList (cons layerName layerList))
  )

  (setq alert_text "We will now save the layer information for automatic 3D modeling.")
  (setq cont_text "Continue?")

  ;; Collect and save selected layers
  (setq selectedLayers (Tokkie "Select wall layers." "" layerList (list "")))
  
  ;; Convert the selectedLayers list to a string
  (setq selectedLayersString (apply 'strcat (mapcar '(lambda (layer) (strcat layer ";")) selectedLayers)))

  (setq xrec '((0 . "XRECORD")(100 . "AcDbXrecord")
	       (1 . "3dleap-wall-dict")))
  ;; Update xrec to include the selectedLayers string
  (setq xrec (append xrec (list (cons 2 selectedLayersString))))

  ;; Create the XRecord entity with the updated xrec
  (setq xname (entmakex xrec))

  ;; Initialize dict
  (if (setq walldict (dictsearch (namedobjdict) "3dleap-wall-dict"))
    (progn
      (setq walldict (dictremove (namedobjdict) "3dleap-wall-dict"))
      (entdel walldict)
    )
  )
  
  ;; Add the XRecord to the dictionary
  (dictadd (namedobjdict) "3dleap-wall-dict" xname)
  (setq selectedLayers nil)
  
  ;;;;; door section
  ;; Collect and save selected layers
  (setq selectedLayers (Tokkie "Select door layers." "" layerList (list "")))

  ;; Convert the selectedLayers list to a string
  (setq selectedLayersString (apply 'strcat (mapcar '(lambda (layer) (strcat layer ";")) selectedLayers)))

  (setq xrec '((0 . "XRECORD")(100 . "AcDbXrecord")
	       (1 . "3dleap-door-dict")))
  ;; Update xrec to include the selectedLayers string
  (setq xrec (append xrec (list (cons 2 selectedLayersString))))

  ;; Create the XRecord entity with the updated xrec
  (setq xname (entmakex xrec))

  ;; Initialize dict
  (if (setq mydict (dictsearch (namedobjdict) "3dleap-door-dict"))
    (progn 
      (setq mydict (dictremove (namedobjdict) "3dleap-door-dict"))
      (entdel mydict)
    )
  )
  
  ;; Add the XRecord to the dictionary
  (dictadd (namedobjdict) "3dleap-door-dict" xname)
  (setq selectedLayers nil)
  
  ;;;;; window section
  ;; Collect and save selected layers
  (setq selectedLayers (Tokkie "Select window layers." "" layerList (list "")))

  ;; Convert the selectedLayers list to a string
  (setq selectedLayersString (apply 'strcat (mapcar '(lambda (layer) (strcat layer ";")) selectedLayers)))

  (setq xrec '((0 . "XRECORD")(100 . "AcDbXrecord")
	       (1 . "3dleap-window-dict")))
  ;; Update xrec to include the selectedLayers string
  (setq xrec (append xrec (list (cons 2 selectedLayersString))))

  ;; Create the XRecord entity with the updated xrec
  (setq xname (entmakex xrec))

  ;; Initialize dict
  (if (setq mydict (dictsearch (namedobjdict) "3dleap-window-dict"))
    (progn 
      (setq mydict (dictremove (namedobjdict) "3dleap-window-dict"))
      (entdel mydict)
    )
  )
  
  ;; Add the XRecord to the dictionary
  (dictadd (namedobjdict) "3dleap-window-dict" xname)
  (setq selectedLayers nil)

  (alert "Layer information has been saved. Please upload the floor plan to Moulder.")

  (command "qsave")
  (princ)
)
